/*
 *  OFAIProcessDoc.java
 *
 *
 *  johann, 25/4/2008
 *
 *  $Id: OFAIProcessDoc.jav 2820 2001-11-14 17:15:43Z oana $
 */
package at.ofai.gate;

import java.util.*;
import java.io.*;

import gate.*;
import gate.creole.*;
import gate.util.*;
import gate.corpora.*;

/** 
 * This class is the implementation of the resource OFAIServer
 * 
 */
public class OFAIProcessDoc {

  private gate.CorpusController controller;
  private gate.Corpus corpus;

  public OFAIProcessDoc() {
    throw new gate.util.GateRuntimeException(
        "Need a pipeline filename when creating OFAIProcessDoc");
  }

  public OFAIProcessDoc(java.net.URL pipelineFileURL)
      throws gate.persist.PersistenceException, java.io.IOException,
      gate.creole.ResourceInstantiationException, java.net.URISyntaxException {
    // try to lead the pipeline
    File controllerFile = new File(pipelineFileURL.toURI());
    controller =
        (gate.CorpusController) gate.util.persistence.PersistenceManager.loadObjectFromFile(controllerFile);
    corpus = (gate.Corpus) gate.Factory.createResource("gate.corpora.CorpusImpl");
    controller.setCorpus(corpus);
  }

  public void cleanup() {
  // cleanup and remove the controller and the corpus
  }

  public Document processDocument(Document doc) {
    corpus.add(doc);
    try {
      controller.execute();
    } catch (gate.creole.ExecutionException e) {
      System.err.println("Error executing the controller: " + e);
    }
    corpus.clear();
    return doc;
  }
} // class OFAIProcessDoc

