/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package at.ofai.gate;

import java.util.*;
import java.net.URL;
import java.io.*;

import gate.*;
import gate.creole.*;
import gate.util.*;

/**
 *
 * @author johann
 */
public class OFAIServerBatch {

  public static void main(String[] args) {
    if(args.length < 1) {
      System.err.println("Need the file containing the processing pipeline!");
    }
    String filename = args[0];
    File file = new File(filename);
    URL fileURL = null;
    try {
      fileURL = file.toURI().toURL();
    } catch (Exception e) {
      System.err.println("Could not create URL from filename: "+e);
      System.exit(1);
    }
    try {
      gate.Gate.init();
    } catch (gate.util.GateException e) {
      System.err.println("Could not initialize gate: " + e);
      System.exit(1);
    }
    OFAIServer server = new OFAIServer();
    
    server.setPipelineURL(fileURL);
    server.setPort(8090);
    try {
      server.init();
      server.getServer().join();
    } catch(Exception e) {
      System.err.println("Error initializing server object: "+e);
      System.exit(1);
    }
  }
}
